var timerImmeFlag;
var stationNums = 0,onlineNumBef = 0;
var slaveIds = "",stationIdPolling = "";
var thisStationId;//正在Polling的SID
var hostUrl = "http://" + HOSTIP + ":" + PORT;//"http://127.0.0.1:7788";

//DOCH-->SingleDo
//AOCH-->SingleAo
function postIoAction(ioAction,ioActionType,sid,msid,ioId)
{
    var ioRes;
    console.log("ioSetVal:",ioAction,ioActionType,ioId);
    /*可透過設定timeout得到error狀態*/
    $.ajaxSetup({cache:false,timeout: 5*1000});
    $.ajax(
    {
        type: "POST",
        url: "restful.php",
        data: {
            postSingleIo: "1",
            pSid: sid,
            pMid: msid,
            pType: ioActionType,
            pOffset: ioId,
            pVal: ioAction,
            postUrl: hostUrl + "/DeviceInfoQuery/SetInfo"
        },
        async : false,
        success: function (response) {
            //console.log("response:",response);
            console.log("response:",JSON.parse(response));
            ioRes = JSON.parse(response);
            ioRes = ioRes.Status;
            
        },
        error: function(xhr, status, error) {
            ioRes = false;
        }		
    });
    return ioRes;	
}

function getRtuList()
{
    slaveIds = "";
    //刪除舊有timeout，避免重複導致時間錯亂
    if (timerImmeFlag){
        clearTimeout(timerImmeFlag);
        timerImmeFlag = "";
    }
    //var timeStamp = new Date().getTime();
    //console.log(timeStamp);

    /*可透過設定timeout得到error狀態*/
    $.ajaxSetup({cache:false,timeout: 5*1000});
    $.ajax(
    {
        type: "GET",
        //url: "http://127.0.0.1:7788/DeviceInfoQuery/DeviceNum",
        url: "restful.php",
        data: {
            getRtuList: "1",
            getUrl: hostUrl + "/DeviceInfoQuery/DeviceNum"//"http://61.219.167.34:7788/DeviceInfoQuery/DeviceNum"
        },
        success: function (response) {
            if (response.length <= 0)
            { 
                //Poll不到值或Timeout可以考慮累計5次或10次再刷頁面，避免頁面持續刷新             
                $("#stationList").html("");
                $("#rtu_device_nums").html("");
                $("#rtu_device_online").html("");
                $("#rtu_device_offline").html("");
                stationNums = 0,onlineNumBef = 0;
                $("#alertMsg").show().html("Without any RTU device!!");
            }
            else
            {
                $("#alertMsg").hide();
                //console.log(response.length);
                let rtuLists = JSON.parse(response);
                let totalNum = parseInt(rtuLists["DeviceNum"]);

                //先將之前暫存的表清除掉，必做!! 2021-07-13 這樣做似乎會造成每次都需要重新DOM (Forced reflow while executing JavaScript took)
                //造成不必要的Loading，可以改成如果數量改變時再做!!
                let onlineNum = 0,offlineNum = 0;
                let stationListHtml = "";
                //$("#stationList").html("");
                $("#rtu_device_nums").html("");
                $("#rtu_device_online").html("");
                $("#rtu_device_offline").html("");
                if(totalNum > 0){ 
                    $("#rtu_device_nums").html(totalNum);
                    for (let i = 0;i < totalNum;i++)
                    {
                        let stationId = rtuLists["StationID"][i];
                        stationListHtml += '<tr id="list_'+stationId+'" style="cursor:pointer" onclick="pollModbus('+stationId+')">';

                        if (rtuLists["Status"][i] == "online")
                        {
                            onlineNum++;
                            stationListHtml += '<td><span class="label label-primary">Online</span></td>';
                        }
                        else if (rtuLists["Status"][i] == "offline")
                        {
                            offlineNum++;
                            stationListHtml += '<td><span class="label label-default">Offline</span></td>';
                        }

                        stationListHtml += '<td>'+rtuLists["StationID"][i]+'</td>';
                        stationListHtml += '<td>'+rtuLists["ModuleName"][i]+'</td>';
                        stationListHtml += '<td>'+rtuLists["ModbusNum"][i]+'</td>';
                        stationListHtml += '<td>-</td>';
                        stationListHtml += '<td><a href="#"><span id="poll_'+stationId+'" class="label label-primary">Poll</span></a></td>';
                        stationListHtml += '</tr>';

                        //Modbus Slaves
                        if (slaveIds == "")
                            slaveIds = stationId+"<"+rtuLists["ModbusNum"][i]+"<"+rtuLists["SlaveID"][i]+"<"+rtuLists["ModbusName"][i];
                        else
                            slaveIds += ";"+stationId+"<"+rtuLists["ModbusNum"][i]+"<"+rtuLists["SlaveID"][i]+"<"+rtuLists["ModbusName"][i];
                    }
                    $("#rtu_device_online").html(onlineNum);
                    $("#rtu_device_offline").html(offlineNum);

                    if (stationNums != totalNum || onlineNumBef != onlineNum)
                    {
                        //console.log("nums change!");
                        //console.log(stationNums,totalNum,onlineNumBef,onlineNum);

                        $('#dataTable_station').DataTable().destroy();

                        $("#stationList").html(stationListHtml);
                        onlineNumBef = onlineNum;

                        $('#dataTable_station').DataTable({
                            "order": [[ 0, "desc" ]], //asc,desc
                            pageLength: 10,
                            responsive: true,
                            buttons: [
                                // { extend: 'copy'},
                                // {extend: 'csv'}
                            ]

                        });
                        $('#dataTable_station').DataTable();
                        stationNums = totalNum; //Update stationNums
                    }

                                       
                }// End if(totalNum > 0){ 
                else
                {
                    //Error or Nothing
                }
            }
                
            //$("#currDate").text(date_time);
            
        },
        error: function(xhr, status, error) {
            console.log(error);
            //$("#loadingImg").hide();
            //alert(xhr.status);
            $("#stationList").html("");
            $("#rtu_device_nums").html("");
            $("#rtu_device_online").html("");
            $("#rtu_device_offline").html("");
            stationNums = 0,onlineNumBef = 0;
            //如果RESTFUL API服務被關閉，會有此問題
            $("#alertMsg").show().html("Abnormal communication with RTU!!");
            //文字顯示Poll失敗，服務未啟動或通訊異常
        }			
    });

    timerImmeFlag = setTimeout(getRtuList, 3000); //不適合輪詢更新，會影響到Table分頁，但可檢查數量是否不同再來更新!!
}

//棄用
function getRtuListDevice()
{
    $.get( "http://61.219.167.34:7788/DeviceInfoQuery/DeviceNum" )
    .done(function( data ) {
        console.log(data);
    })
    .fail(function() {
        //NG
        
    });
}

function pollModbus(stationId)
{
    thisStationId = stationId;//更新正在Polling的SID
    //將之前的stationId外的css改為label-success
    //console.log(stationIdPolling,stationId);
    $("#poll_"+stationIdPolling).html("Poll").removeClass("label-danger").addClass("label-primary");
    //修改目前正在poll的id
    stationIdPolling = stationId;

    $("#poll_"+stationId).html("Polling").removeClass("label-primary").addClass("label-danger");
    //$("#mainBoard").removeClass("col-lg-12").addClass("col-lg-6");
    $("#mainBoardChevron").removeClass("fa-chevron-up").addClass("fa-chevron-down");
    $("#mainBoardContents").hide();
    
    $("#modbusBoard").show().focus(); //focus目前放這邊似乎沒效果(手機版)

    //slaveIdList
    //1<11<255,11,22,33,44,55,66,77,88,99,100<G-4500,MB_1111,MB_2222,MB_33,MB_44,MB_55,MB_66,MB_77,MB_88,MB_99,MB_10;2<11<255,11,22,33,44,55,66,77,88,99,100<G-4500,MB_1111,MB_2222,MB_33,MB_44,MB_55,MB_66,MB_77,MB_88,MB_99,MB_10;
    //console.log(slaveIds);
    var slaveIdsList = new Array()
    slaveIdsList = slaveIds.split(";");
    //console.log(slaveIdsList.length);
    //index 0 是Modbus Num
    $("#slaveIdList").html("");
    let slaveHtml = "";
    let slaveIoHtml = "";
    for (let i = 0;i < slaveIdsList.length;i++)
    {
        slaveIdList = slaveIdsList[i].split("<");      
        //console.log(stationId,slaveIdList[0]);
        if (stationId == parseInt(slaveIdList[0]))
        {        
            //console.log(stationId,slaveIdList[1]);
            for (let j = 0;j < parseInt(slaveIdList[1]);j++)
            {
                
                //Tab Left
                slaveIdLists = slaveIdList[2].split(",");
                slaveNameLists = slaveIdList[3].split(",");
                if (j == 0) //set active
                    slaveHtml += '<li><a class="nav-link active" data-toggle="tab" href="#tab-'+stationId+'-'+slaveIdLists[j]+'">';
                else
                    slaveHtml += '<li><a class="nav-link" data-toggle="tab" href="#tab-'+stationId+'-'+slaveIdLists[j]+'">';
                slaveHtml += '<small class="text-muted">'+slaveIdLists[j]+'</small>';
                slaveHtml += '<div><strong>'+slaveNameLists[j]+'</strong></div>';                                           
                slaveHtml += '</a></li>'; 

                $("#slaveIdList").append(slaveHtml);                                                       
                getSlaveIo(parseInt(stationId),parseInt(slaveIdLists[j]),slaveIdLists);
                slaveHtml = "";
            }          
        }
        else
        {
            //break;
        }
            
    }
    //$("#slaveIdList").html(slaveHtml);
    
}

function getSlaveIo(stationId,slaveId,slaveIdLists)
{
    //console.log(stationId,slaveId,slaveIdLists);
    let slaveIoHtml = "";
    $("#slaveIosList").html("");
    //http://61.219.167.34:7788/DeviceInfoQuery/1,33
    $.ajaxSetup({cache:false,timeout: 5*1000});
    $.ajax(
    {
        type: "GET",
        url: "restful.php",
        data: {
            getRtuList: "1",
            getUrl: hostUrl + "/DeviceInfoQuery/"+stationId+","+slaveId
        },
        success: function (response) {
            if (response.length <= 0)
            { 
                $("#rtu_device_nums").html("");
                $("#rtu_device_online").html("");
                $("#rtu_device_offline").html("");
                $("#alertMsg").show().html("Without any Modbus device!!");
            }
            else
            {
                $("#alertMsg").hide();
                let slaveLists = JSON.parse(response);
                //console.log(slaveLists);

                if(slaveLists["Status"] == "offline" || slaveLists["Status"] == "invalid")
                {
                    //Offline or NO this slave id
                }
                else
                {
                    //Online
                    //Tab Right
                    let DIs = slaveLists["DI"].split(",");
                    let DOs = slaveLists["DO"].split(",");
                    let AIs = slaveLists["AI"].split(",");
                    let AOs = slaveLists["AO"].split(",");
                    let CNTs = slaveLists["Counter"].split(",");
                    let dateTime = slaveLists["DateTime"];
                    //console.log(DIs,DOs,AIs,AOs,CNTs);
                    let DIsLength = 0,DOsLength = 0,CNTsLength = 0,AIsLength = 0,AOsLength = 0;
                    if (DIs == "null")
                        DIsLength = 0;
                    else
                        DIsLength = DIs.length;
                    if (DOs == "null")
                        DOsLength = 0;
                    else
                        DOsLength = DOs.length;
                    if (AIs == "null")
                        AIsLength = 0;
                    else
                        AIsLength = AIs.length;
                    if (AOs == "null")
                        AOsLength = 0;
                    else
                        AOsLength = AOs.length;
                    if (CNTs == "null")
                        CNTsLength = 0;
                    else
                        CNTsLength = CNTs.length;

                    //Modbus Slave IO Status
                    if (parseInt(slaveIdLists[0]) == slaveId) //First Slave ID is active
                        slaveIoHtml += '<div id="tab-'+stationId+'-'+slaveId+'" class="tab-pane active"><div class="panel-body">';
                    else
                        slaveIoHtml += '<div id="tab-'+stationId+'-'+slaveId+'" class="tab-pane"><div class="panel-body">';
                    slaveIoHtml += '<table class="table"><tbody><tr><td>';
                    slaveIoHtml += '<button type="button" class="btn btn-primary m-r-sm">Online</button>Status</td>';
                    slaveIoHtml += '<td colspan="2" class="text-muted"><button type="button" class="btn btn-primary m-r-sm">Date&Time</button>';
                    //Slave的最後Datetime
                    slaveIoHtml += '<i class="fa fa-clock-o"></i> '+dateTime+'</td></tr>'; 
                    //DI,DO,CNTs
                    slaveIoHtml += '<tr><td><button type="button" class="btn btn-primary m-r-sm">'+DIsLength+'</button>DI</td>';
                    slaveIoHtml += '<td><button type="button" class="btn btn-primary m-r-sm">'+DOsLength+'</button>DO</td>';
                    slaveIoHtml += '<td><button type="button" class="btn btn-primary m-r-sm">'+CNTsLength+'</button>CNTs</td></tr>';
                    //
                    slaveIoHtml += '<tr><td><button type="button" class="btn btn-default m-r-sm">'+AIsLength+'</button>AI</td>';
                    slaveIoHtml += '<td><button type="button" class="btn btn-default m-r-sm">'+AOsLength+'</button>AO</td>';
                    if (slaveLists["GPS"] == "null")
                        slaveIoHtml += '<td><button id="gps_show_map" type="button" class="btn btn-default m-r-sm">NO</button>GPS</td></tr>';
                    else
                        slaveIoHtml += '<td><button id="gps_show_map" type="button" class="btn btn-primary m-r-sm">YES</button>GPS</td></tr>';
                    slaveIoHtml += '</tbody></table>';        
                    //Other
                    //slaveIoHtml += '</div></div>';    

                    //IO Title
                    slaveIoHtml += '<div class="tabs-container"><div class="tabs-left"><ul class="nav nav-tabs">';
                    let setActive = "active";
                    if (DIsLength > 0)
                    {
                        slaveIoHtml += '<li><a class="nav-link '+setActive+'" data-toggle="tab" href="#tab-'+stationId+'-'+slaveId+'-DItab">DI</a></li>';
                        setActive = "";
                    }
                    if (DOsLength > 0)
                    {
                        slaveIoHtml += '<li><a class="nav-link '+setActive+'" data-toggle="tab" href="#tab-'+stationId+'-'+slaveId+'-DOtab">DO</a></li>';
                        setActive = "";
                    }
                    if (CNTsLength > 0)
                    {
                        slaveIoHtml += '<li><a class="nav-link '+setActive+'" data-toggle="tab" href="#tab-'+stationId+'-'+slaveId+'-CNTtab">CNTs</a></li>';
                        setActive = "";
                    }
                    if (AIsLength > 0)
                    {
                        slaveIoHtml += '<li><a class="nav-link '+setActive+'" data-toggle="tab" href="#tab-'+stationId+'-'+slaveId+'-AItab">AI</a></li>';
                        setActive = "";
                    }
                    if (AOsLength > 0)
                    {
                        slaveIoHtml += '<li><a class="nav-link '+setActive+'" data-toggle="tab" href="#tab-'+stationId+'-'+slaveId+'-AOtab">AO</a></li>';
                        setActive = "";
                    }
                    slaveIoHtml += '</ul><div class="tab-content ">';
                    
                    setActive = "active";
                    //先長滿框架，再隱藏，可避免顯示框不夠大
                    //2021-12-03 即時更新待加入!!
                    let dNums = 0;
                    if (DIsLength > 0)
                    {
                        //console.log(DIs);
                        slaveIoHtml += '<div id="tab-'+stationId+'-'+slaveId+'-DItab" class="tab-pane '+setActive+'"><div class="panel-body"><div class="table-responsive">';
                        slaveIoHtml += '<table class="table table-striped table-bordered table-hover dataTables-status" ><tbody>'; 
                        
                        //先長出32 DI位置
                        while (dNums < 32)
                        {
                            if (dNums == 0)
                            {
                                slaveIoHtml += '<tr>';
                            }
                            if (dNums == 0 || dNums == 3 || dNums == 7 || dNums == 9 || dNums == 12)
                            {
                                if (dNums < DIsLength)
                                {
                                    if (parseInt(DIs[dNums]) == 1)
                                        slaveIoHtml += '<td><span class="label label-danger">DI'+dNums+'</span></td>'; 
                                    else
                                        slaveIoHtml += '<td><span class="label">DI'+dNums+'</span></td>'; 
                                }
                                else
                                {
                                    //slaveIoHtml += '<td><span>&nbsp</span></td>'; 
                                    slaveIoHtml += '<td><span class="label">&nbsp</span></td>'; 
                                }
                            }
                            else
                            {   
                                if (dNums < DIsLength)
                                {
                                    if (parseInt(DIs[dNums]) == 1)
                                        slaveIoHtml += '<td><span class="label label-danger">DI'+dNums+'</span></td>'; 
                                    else
                                        slaveIoHtml += '<td><span class="label">DI'+dNums+'</span></td>'; 
                                }
                                else
                                {
                                    //slaveIoHtml += '<td><span>&nbsp</span></td>'; 
                                    slaveIoHtml += '<td><span class="label">&nbsp</span></td>'; 
                                }
                            }
                              
                            if (dNums == 5 || dNums == 11 || dNums == 17 || dNums == 23 || dNums == 29)
                            {
                                slaveIoHtml += '</tr><tr>';
                            }
                            if (dNums == 31)
                            {
                                slaveIoHtml += '</tr>';
                            }
                            dNums++;
                        }
                        dNums = 0;
                        /* slaveIoHtml += '<td><span class="label label-danger">DI0</span></td>';    
                        slaveIoHtml += '<td><span class="label label-default">DI1</span></td>';  
                        slaveIoHtml += '<td><span class="label label-danger">DI2</span></td>';  */ 
                        
                        slaveIoHtml += '</tr></tbody></table></div></div></div>';    
                        setActive = "";                            
                    }
                    if (DOsLength > 0)
                    {
                        dNums = 0;
                        slaveIoHtml += '<div id="tab-'+stationId+'-'+slaveId+'-DOtab" class="tab-pane '+setActive+'"><div class="panel-body"><div class="table-responsive">';
                        slaveIoHtml += '<table class="table table-striped table-bordered table-hover dataTables-status" ><tbody>';    

                        //先長出32 DO位置
                        while (dNums < 32)
                        {
                            if (dNums == 0)
                            {
                                slaveIoHtml += '<tr>';
                            }
                            if (dNums == 1 || dNums == 4 || dNums == 8 || dNums == 9 || dNums == 10 || dNums == 18 || dNums == 20)
                            {
                                if (dNums < DOsLength)
                                {
                                    if (parseInt(DOs[dNums]) == 1)
                                        slaveIoHtml += '<td><span class="label label-danger">DO'+dNums+'</span><button class="btn btn-default postDoOff" value='+stationId+'-'+slaveId+'-'+dNums+'><i class="fa fa-arrow-down"></i> Trigger</button></td>';  
                                    else
                                        slaveIoHtml += '<td><span class="label">DO'+dNums+'</span><button class="btn btn-default postDoOn" value='+stationId+'-'+slaveId+'-'+dNums+'><i class="fa fa-arrow-down"></i> Trigger</button></td>';    
                                }
                                else
                                {
                                    slaveIoHtml += '<td><span class="label">&nbsp</span></td>';  
                                }                             
                            }
                            else
                            {
                                if (dNums < DOsLength)
                                {
                                    if (parseInt(DOs[dNums]) == 1)
                                        slaveIoHtml += '<td><span class="label label-danger">DO'+dNums+'</span><button class="btn btn-default postDoOff" value='+stationId+'-'+slaveId+'-'+dNums+'><i class="fa fa-arrow-down"></i> Trigger</button></td>';  
                                    else
                                        slaveIoHtml += '<td><span class="label">DO'+dNums+'</span><button class="btn btn-default postDoOn" value='+stationId+'-'+slaveId+'-'+dNums+'><i class="fa fa-arrow-down"></i> Trigger</button></td>';     
                                }
                                else
                                {
                                    slaveIoHtml += '<td><span class="label">&nbsp</span></td>';  
                                }
                            }
                            
                            if (dNums == 5 || dNums == 11 || dNums == 17 || dNums == 23 || dNums == 29)
                            {
                                slaveIoHtml += '</tr><tr>';
                            }
                            if (dNums == 31)
                            {
                                slaveIoHtml += '</tr>';
                            }
                            dNums++;
                        }
                        dNums = 0;

                        slaveIoHtml += '</tbody></table></div></div></div>';
                        setActive = "";
                    }
                    if (CNTsLength > 0)
                    {
                        dNums = 0;
                        slaveIoHtml += '<div id="tab-'+stationId+'-'+slaveId+'-CNTtab" class="tab-pane '+setActive+'"><div class="panel-body"><div class="table-responsive">';
                        slaveIoHtml += '<table class="table table-striped table-bordered table-hover dataTables-status" ><tbody>';                              
                        
                        //先長出32 CNT位置
                        while (dNums < 32)
                        {
                            if (dNums == 0)
                            {
                                slaveIoHtml += '<tr>';
                            }
                            if (dNums < CNTsLength)
                            {
                                slaveIoHtml += '<td><span class="label label-default">CNT'+dNums+'</span><strong style="padding-left:10px;font-size: 16px;">'+CNTs[dNums]+'</strong></td>';    
                            }
                            else
                            {
                                slaveIoHtml += '<td><span class="label">&nbsp</span></td>';  
                            } 
                            //slaveIoHtml += '<td><span class="label label-default">CNT'+dNums+'</span><strong style="padding-left:10px;font-size: 16px;">12<strong></td>';   
                            if (dNums == 5 || dNums == 11 || dNums == 17 || dNums == 23 || dNums == 29)
                            {
                                slaveIoHtml += '</tr><tr>';
                            }
                            if (dNums == 31)
                            {
                                slaveIoHtml += '</tr>';
                            }
                            dNums++;
                        }
                        dNums = 0;

                        slaveIoHtml += '</tbody></table></div></div></div>';
                        setActive = "";
                    }
                    if (AIsLength > 0)
                    {
                        dNums = 0;
                        slaveIoHtml += '<div id="tab-'+stationId+'-'+slaveId+'-AItab" class="tab-pane '+setActive+'"><div class="panel-body"><div class="table-responsive">';
                        slaveIoHtml += '<table class="table table-striped table-bordered table-hover dataTables-status" ><tbody>';                              

                        //先長出32 AI位置
                        while (dNums < 32)
                        {
                            if (dNums == 0)
                            {
                                slaveIoHtml += '<tr>';
                            }
                            if (dNums < AIsLength)
                            {
                                slaveIoHtml += '<td><span class="label label-default">AI'+dNums+'</span><strong style="padding-left:10px;font-size: 16px;">'+AIs[dNums]+'</strong></td>';    
                            }
                            else
                            {
                                slaveIoHtml += '<td><span class="label">&nbsp</span></td>';  
                            } 
                            //slaveIoHtml += '<td><span class="label label-default">AI'+dNums+'</span><strong style="padding-left:10px;font-size: 16px;">60h</strong></td>';   
                            if (dNums == 5 || dNums == 11  || dNums == 17 || dNums == 23 || dNums == 29)
                            {
                                slaveIoHtml += '</tr><tr>';
                            }
                            if (dNums == 31)
                            {
                                slaveIoHtml += '</tr>';
                            }
                            dNums++;
                        }
                        dNums = 0;

                        slaveIoHtml += '</tbody></table></div></div></div>';
                        setActive = "";
                    }
                    if (AOsLength > 0)
                    {
                        dNums = 0;
                        slaveIoHtml += '<div id="tab-'+stationId+'-'+slaveId+'-AOtab" class="tab-pane '+setActive+'"><div class="panel-body"><div class="table-responsive">';
                        slaveIoHtml += '<table class="table table-striped table-bordered table-hover dataTables-status" ><tbody>';                              

                        //先長出32 AO位置
                        while (dNums < 32)
                        {
                            if (dNums == 0)
                            {
                                slaveIoHtml += '<tr>';
                            }
                            if (dNums < AOsLength)
                            {
                                slaveIoHtml += '<td><span class="label label-default">AO'+dNums+'</span><strong style="padding-left:10px;font-size: 16px;">'+AOs[dNums]+'</strong><button class="btn btn-default postAoVal" value='+stationId+'-'+slaveId+'-'+dNums+'-'+AOs[dNums]+'><i class="fa fa-pencil-square-o"></i> Update</button></td>';    
                            }
                            else
                            {
                                slaveIoHtml += '<td><span class="label">&nbsp</span></td>';  
                            }
                            //slaveIoHtml += '<td><span class="label label-default">AO'+dNums+'</span><strong style="padding-left:10px;font-size: 16px;">80h</strong><button class="btn btn-default"><i class="fa fa-pencil-square-o"></i> Update</button></td>';   
                            if (dNums == 5 || dNums == 11  || dNums == 17 || dNums == 23 || dNums == 29)
                            {
                                slaveIoHtml += '</tr><tr>';
                            }
                            if (dNums == 31)
                            {
                                slaveIoHtml += '</tr>';
                            }
                            dNums++;
                        }
                        dNums = 0;

                        slaveIoHtml += '</tbody></table></div></div></div>';
                        setActive = "";
                    }

                    //end
                    slaveIoHtml += '</div></div></div></div></div>';

                    $("#slaveIosList").append(slaveIoHtml);

                    $( "#gps_show_map" ).click(function() {
                        $( "#show_map" ).show();
        
                        let gprmc = "$GPRMC,015520.00,A,2406.41630,N,12042.94201,E,23.839,152.99,150416,,,A*54";
                        parsingNMEA(gprmc);
                
                    });
                }
            }
            //console.log(slaveIoHtml);

            //Bind Click Event
            $('.postDoOff').click(function () {
                let doIds = this.value;
                doIds = doIds.split("-");
                let sid = doIds[0];
                let msid = doIds[1];
                let doId = doIds[2];
                //console.log("postDoOff",this.value);
                Swal.fire({
                    title: "Are you sure to set Do Off!?",
                    text: "You will not be able to restore this triggered action!",
                    icon: "warning",
                    showCancelButton: true,
                    confirmButtonColor: "#3085d6",
                    cancelButtonColor: '#d33',
                    confirmButtonText: "Yes, triggered it!"
                }).then((result) => {
                    if (result.isConfirmed) {
                        //console.log(doId);
                        let res = postIoAction("0","DOCH",sid,msid,doId);
                        console.log(res);
                        if (res == "ok")
                        {
                            //Update IO Status
                            Swal.fire("Will Set Do OFF!", "Do is OFF.", "success");
                        }
                        else
                        {
                            Swal.fire("Trigger failed!!", "Post Err!!", "success");
                        }
                    }            
                });
            });
            $('.postDoOn').click(function () {
                let doIds = this.value;
                doIds = doIds.split("-");
                let sid = doIds[0];
                let msid = doIds[1];
                let doId = doIds[2];
                //console.log("postDoOn",this.value);
                Swal.fire({
                    title: "Are you sure to set Do On!?",
                    text: "You will not be able to restore this triggered action!",
                    icon: "warning",
                    showCancelButton: true,
                    confirmButtonColor: "#3085d6",
                    cancelButtonColor: '#d33',
                    confirmButtonText: "Yes, triggered it!"
                }).then((result) => {
                    if (result.isConfirmed) {
                        //console.log(doId);
                        let res = postIoAction("1","DOCH",sid,msid,doId);
                        console.log(res);
                        if (res == "ok")
                        {
                            //Update IO Status
                            Swal.fire("Will Set Do ON!", "Do is ON.", "success");
                        }
                        else
                        {
                            Swal.fire("Trigger failed!!", "Post Err!!", "error");
                        }
                    }
                });
            });
            $('.postAoVal').click(function () {
                let aoIds = this.value;
                aoIds = aoIds.split("-");
                let sid = aoIds[0];
                let msid = aoIds[1];
                let aoId = aoIds[2];
                let aoIdVal = aoIds[3];
                console.log("postAoVal",this.value,aoIdVal);
                Swal.fire({
                    title: 'Write Ao~',
                    input: 'text',
                    inputAttributes: {
                      autocapitalize: 'off'
                    },
                    showCancelButton: true,
                    confirmButtonText: 'Write it!!',
                    showLoaderOnConfirm: true,
                    preConfirm: (aoVal) => {
                        //console.log(aoVal);
                        let res = postIoAction(aoVal,"AOCH",sid,msid,aoId);
                        if (res == "ok")
                        {
                            //Update IO Status
                            Swal.fire("Will Set Do ON!", "Do is ON.", "success");
                        }
                        else
                        {
                            Swal.fire("Trigger failed!!", "Post Err!!", "error");
                        }
                    }
                }).then((result) => {
                    if (result.isConfirmed) {
                        
                    }
                })
            });
            
        },
        error: function(xhr, status, error) {
            $("#alertMsg").show().html("Abnormal communication with RTU!!");
        }			
    });

    
}

function parsingNMEA(gprmc)
{
    //$GPRMC,015520.00,A,2406.41630,N,12042.94201,E,23.839,152.99,150416,,,A*54
    //$GPGGA,121253.000,3937.3090,N,11611.6057,E,1,06,1.2,44.6,M,-5.7,M,,0000*72

    /* Recommended Minimum Specific GPS/TRANSIT Data（RMC）推薦定位資訊
    $GPRMC,<1>,<2>,<3>,<4>,<5>,<6>,<7>,<8>,<9>,<10>,<11>,<12>*hh
    <1> UTC時間，hhmmss（時分秒）格式 
    <2> 定位狀態，A=有效定位，V=無效定位 
    <3> 緯度ddmm.mmmm（度分）格式（前面的0也將被傳輸） 
    <4> 緯度半球N（北半球）或S（南半球） 
    <5> 經度dddmm.mmmm（度分）格式（前面的0也將被傳輸） 
    <6> 經度半球E（東經）或W（西經） 
    <7> 地面速率（000.0~999.9節，前面的0也將被傳輸） 
    <8> 地面航向（000.0~359.9度，以真北為參考基準，前面的0也將被傳輸） 
    <9> UTC日期，ddmmyy（日月年）格式 
    <10> 磁偏角（000.0~180.0度，前面的0也將被傳輸） 
    <11> 磁偏角方向，E（東）或W（西） 
    <12> 模式指示（僅NMEA0183 3.00版本輸出，A=自主定位，D=差分，E=估算，N=資料無效） */

    /* Global Positioning System Fix Data（GGA）GPS定位資訊
    $GPGGA,<1>,<2>,<3>,<4>,<5>,<6>,<7>,<8>,<9>,M,<10>,M,<11>,<12>*hh
    <1> UTC時間，hhmmss（時分秒）格式 
    <2> 緯度ddmm.mmmm（度分）格式（前面的0也將被傳輸） 
    <3> 緯度半球N（北半球）或S（南半球） 
    <4> 經度dddmm.mmmm（度分）格式（前面的0也將被傳輸） 
    <5> 經度半球E（東經）或W（西經） 
    <6> GPS狀態：0=未定位，1=非差分定位，2=差分定位，6=正在估算 
    <7> 正在使用解算位置的衛星數量（00~12）（前面的0也將被傳輸） 
    <8> HDOP水準精度因數（0.5~99.9） 
    <9> 海拔高度（-9999.9~99999.9） 
    <10> 地球橢球面相對大地水準面的高度 
    <11> 差分時間（從最近一次接收到差分信號開始的秒數，如果不是差分定位將為空） 
    <12> 差分站ID號0000~1023（前面的0也將被傳輸，如果不是差分定位將為空） */

    let lat; //latitude 緯度
    let lng; //longitude 經度
    let ifPositioning = 0;

    gprmcList = gprmc.split(",");
    console.log(gprmcList);
    //NEMA
    switch(gprmcList[0])
    {
        case "$GPRMC": //GPS
        case "$GNRMC": //Combined GPS and GLONASS or BDS
        case "$BDRMC": //BDS,Beidou 
            //gprmc = "$GPRMC,015520.00,A,2406.41630,N,12042.94201,E,23.839,152.99,150416,,,A*54";
            
            //console.log(gprmc2Wgs84(gprmcList[3]));
            //console.log(gprmc2Wgs84(gprmcList[5]));
            if (gprmcList[2] == "A")
            {
                lat = gprmc2Wgs84(gprmcList[3]);
                lng = gprmc2Wgs84(gprmcList[5]);
                ifPositioning = 1;
            }
            else
            {
                lat = "";
                lng = "";
                ifPositioning = 0;
            }
            break;
        case "$GPGGA": //GPS
        case "$GNGGA": //Combined GPS and GLONASS or BDS
        case "$BDGGA": //BDS,Beidou
            break;
    }

    if (ifPositioning == 1)
    {
        map = L.map('map').setView([lat,lng], 17);
        L.tileLayer('https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png', {
            attribution: '<a href="https://www.openstreetmap.org/">OSM</a>',
            maxZoom: 18,
        }).addTo(map);
        var marker = L.marker([lat,lng]);
        marker.addTo(map);

        $( "#map" ).focus();
    }
    else
    {
        //Show No positioning
    }
}

function gprmc2Wgs84(v) 
{
    let pointIndex = v.indexOf(".");
    if (pointIndex == -1) return null;
    let h = v.substr(0, pointIndex - 2);
    if (h.indexOf("-") !== -1) {//if minus
    return Number(h) - Number(v.substring(pointIndex - 2)) / 60;
    } else {
    return Number(h) + Number(v.substring(pointIndex - 2)) / 60;
    }
}